// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import Foundation
import XCTest
@testable import AppleExtensions

class UIViewExtensionTests: XCTestCase {

    func testAddSubviewWithEdgeInsets() {
        let view = UIView()
        let view2 = UIView()
        let superview = UIView(frame: CGRect(x: 0, y: 0, width: 200, height: 200))

        superview.addSubview(view, withEdgeInsets: .zero)
        superview.addSubview(view2, withEdgeInsets: UIEdgeInsets(top: 50, left: 50, bottom: 50, right: 50))
        superview.layoutIfNeeded()
        XCTAssert(superview.bounds.equalTo(view.frame))
        XCTAssert(superview.bounds.insetBy(dx: 50, dy: 50).equalTo(view2.frame))
    }
}
