// swift-tools-version:5.3
// The swift-tools-version declares the minimum version of Swift required to build this package.

// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import PackageDescription

let package = Package(
    name: "Data",
    platforms: [
        .iOS(.v10)
    ],
    products: [
        .library(
            name: "CMSData",
            targets: ["CMSData"]
        ),
        .library(
            name: "ErrorData",
            targets: ["ErrorData"]
        ),
        .library(
            name: "GMAppData",
            targets: ["GMAppData"]
        ),
        .library(
            name: "UIData",
            targets: ["UIData"]
        )
    ],
    dependencies: [ ],
    targets: [
        .target(
            name: "CMSData",
            dependencies: [],
            path: "Sources/CMS"
        ),
        .target(
            name: "ErrorData",
            dependencies: [
                .byName(name: "GMAppData")
            ],
            path: "Sources/Errors"
        ),
        .target(
            name: "GMAppData",
            dependencies: [],
            path: "Sources/GMApp"
        ),
        .target(
            name: "UIData",
            dependencies: [],
            path: "Sources/UI"
        ),

        // MARK: - Tests
        .testTarget(
            name: "CMSDataTests",
            dependencies: ["CMSData"],
            path: "Tests/CMSTests"
        )
    ]
)
