public struct Activity: Codable, Hashable, Identifiable {

    public enum Performer: String, Codable, CaseIterable {
        case hospital = "HOSPITAL"
        case doctor = "OWN_DOCTOR"
        case dueDate = "DUE_DATE"
        case heatlhcareProvider = "HEALTHCARE_PROVIDER"
    }

    public var scheduledString: String
    public var title: String
    public var description: String
    public var untilWeek: Int
    public var performer: Performer
    public var id: String
    public var isAfterBirth: Bool

    public init(scheduledString: String, title: String, description: String, untilWeek: Int, performer: Performer, id: String, isAfterBirth: Bool) {
        self.scheduledString = scheduledString
        self.title = title
        self.description = description
        self.untilWeek = untilWeek
        self.performer = performer
        self.id = id
        self.isAfterBirth = isAfterBirth
    }

    enum CodingKeys: CodingKey {
        case scheduledString
        case title
        case description
        case untilWeek
        case performer
        case id
        case isAfterBirth
    }
    
    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(scheduledString, forKey: .scheduledString)
        try container.encode(title, forKey: .title)
        try container.encodeIfPresent(untilWeek, forKey: .untilWeek)
        try container.encodeIfPresent(performer, forKey: .performer)
        try container.encode(id, forKey: .id)
        try container.encode(isAfterBirth, forKey: .isAfterBirth)
    }
}
