//
// ExpectedDateOfDeliverySection.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ExpectedDateOfDeliverySection: Codable, Hashable {

    public var modifiedTime: Date?
    public var author: HealthCareOrganization?
    public var dirty: Bool?
    public var expectedDateOfDeliveryFromLastPeriod: ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod?
    /** Computed conception date. Computed either from ultrasound gestation age or from last period. */
    public var offsetDate: Date?
    /** Computed date of delivery. Computed either from ultrasound gestation age or from last period. */
    public var dateOfDelivery: Date?
    /** Computed gestation age formatted as 'Weeks+Days'. Computed from 273 days minus days to expectedDateOfDeliveryFromPrenatalUltrasoundScan if present. Otherwise computed from expectedDateOfDeliveryFromLastPeriod. */
    public var gestationAge: String?
    /** Computed trimester (i.e. monthsIntoPregnancy/3). */
    public var trimester: Int?
    /** Computed number of months into pregnanancy. Computed from expectedDateOfDeliveryFromPrenatalUtrasoundScan if presenent and expectedDateOfDeliveryFromLastPeriod otherwise. If both are null this wil be 0 */
    public var monthsIntoPregnancy: Double?
    /** Computed Gestation Week. Computed from gestationAge. '17+6' = 18 and '18+0' = 19 */
    public var week: Int?
    public var remarks: String?

    public init(modifiedTime: Date? = nil, author: HealthCareOrganization? = nil, dirty: Bool? = nil, expectedDateOfDeliveryFromLastPeriod: ExpectedDateOfDeliverySectionAllOfExpectedDateOfDeliveryFromLastPeriod? = nil, offsetDate: Date? = nil, dateOfDelivery: Date? = nil, gestationAge: String? = nil, trimester: Int? = nil, monthsIntoPregnancy: Double? = nil, week: Int? = nil, remarks: String? = nil) {
        self.modifiedTime = modifiedTime
        self.author = author
        self.dirty = dirty
        self.expectedDateOfDeliveryFromLastPeriod = expectedDateOfDeliveryFromLastPeriod
        self.offsetDate = offsetDate
        self.dateOfDelivery = dateOfDelivery
        self.gestationAge = gestationAge
        self.trimester = trimester
        self.monthsIntoPregnancy = monthsIntoPregnancy
        self.week = week
        self.remarks = remarks
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case modifiedTime
        case author
        case dirty
        case expectedDateOfDeliveryFromLastPeriod
        case offsetDate
        case dateOfDelivery
        case gestationAge
        case trimester
        case monthsIntoPregnancy
        case week
        case remarks
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(modifiedTime, forKey: .modifiedTime)
        try container.encodeIfPresent(author, forKey: .author)
        try container.encodeIfPresent(dirty, forKey: .dirty)
        try container.encodeIfPresent(expectedDateOfDeliveryFromLastPeriod, forKey: .expectedDateOfDeliveryFromLastPeriod)
        try container.encodeIfPresent(offsetDate, forKey: .offsetDate)
        try container.encodeIfPresent(dateOfDelivery, forKey: .dateOfDelivery)
        try container.encodeIfPresent(gestationAge, forKey: .gestationAge)
        try container.encodeIfPresent(trimester, forKey: .trimester)
        try container.encodeIfPresent(monthsIntoPregnancy, forKey: .monthsIntoPregnancy)
        try container.encodeIfPresent(week, forKey: .week)
        try container.encodeIfPresent(remarks, forKey: .remarks)
    }
}

