//
// Observation.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Observation: Codable, Hashable {

    public var dateOfMeasurement: Date
    public var values: [ObservationValues]
    public var measuredBy: HealthCarePerformer?
    public var fetus: String?
    /** the id of the activity this observation is created in context of. */
    public var activityReference: String?
    public var type: ObservationType?
    /** DocumentUnique Id for the CDA document */
    public var id: String?

    public init(dateOfMeasurement: Date, values: [ObservationValues], measuredBy: HealthCarePerformer? = nil, fetus: String? = nil, activityReference: String? = nil, type: ObservationType? = nil, id: String? = nil) {
        self.dateOfMeasurement = dateOfMeasurement
        self.values = values
        self.measuredBy = measuredBy
        self.fetus = fetus
        self.activityReference = activityReference
        self.type = type
        self.id = id
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case dateOfMeasurement
        case values
        case measuredBy
        case fetus
        case activityReference
        case type
        case id
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(dateOfMeasurement, forKey: .dateOfMeasurement)
        try container.encode(values, forKey: .values)
        try container.encodeIfPresent(measuredBy, forKey: .measuredBy)
        try container.encodeIfPresent(fetus, forKey: .fetus)
        try container.encodeIfPresent(activityReference, forKey: .activityReference)
        try container.encodeIfPresent(type, forKey: .type)
        try container.encodeIfPresent(id, forKey: .id)
    }
}

