//
// ProblemDetails.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** A way to carry machine-readable details of errors in a HTTP response to avoid the need to define new error response formats for HTTP APIs. See [RFC7807](https://tools.ietf.org/rfc/rfc7807.txt)  */
public struct ProblemDetails: Codable, Hashable {

    /** A URI reference [RFC3986](https://tools.ietf.org/rfc/rfc3986.txt) that identifies the problem type.  */
    public var type: String?
    /** A short, human-readable summary of the problem type.  */
    public var title: String?
    /** The HTTP status code [([RFC7231], Section 6)](https://tools.ietf.org/rfc/rfc7231.txt#section-6) generated by the origin server for this occurrence of the problem.  */
    public var status: Double?
    /** A URI reference that identifies the specific occurrence of the problem.  */
    public var instance: String?
    /** A human-readable explanation specific to this occurrence of the problem.  */
    public var detail: String?
    /** Debugging information for DEV and QA environments.  */
    public var debugging: String?
    /** An array of validation errors.  */
    public var invalidParams: Set<ProblemDetailsInvalidParams>?

    public init(type: String? = nil, title: String? = nil, status: Double? = nil, instance: String? = nil, detail: String? = nil, debugging: String? = nil, invalidParams: Set<ProblemDetailsInvalidParams>? = nil) {
        self.type = type
        self.title = title
        self.status = status
        self.instance = instance
        self.detail = detail
        self.debugging = debugging
        self.invalidParams = invalidParams
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case type
        case title
        case status
        case instance
        case detail
        case debugging
        case invalidParams = "invalid-params"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(type, forKey: .type)
        try container.encodeIfPresent(title, forKey: .title)
        try container.encodeIfPresent(status, forKey: .status)
        try container.encodeIfPresent(instance, forKey: .instance)
        try container.encodeIfPresent(detail, forKey: .detail)
        try container.encodeIfPresent(debugging, forKey: .debugging)
        try container.encodeIfPresent(invalidParams, forKey: .invalidParams)
    }
}

