//
// SaveRegularObservationsRequest.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** Post or put this to the server to save or create up to one of each observation type related to an ultrasound scan */
public struct SaveRegularObservationsRequest: Codable, Hashable {

    /** the ID of the careplan activity that these observations are pointing to (using a cross reference) */
    public var activityId: String?
    /** the unique uuid of the cda document */
    public var documentUniqueId: String?
    /** time of the measurement (shall be able to put back in time) will default to now */
    public var date: Date?
    /** time of the conception. This field is needed to calculate gestation age */
    public var offsetDate: Date?
    public var weight: Double?
    public var bloodPressure: SaveRegularObservationsRequestBloodPressure?
    /** Each Urin observation as an entry eg. [\"+A\", \"S\", \"Leu] */
    public var urine: [String]?
    public var edema: String?
    public var pubismeasurement: Double?
    public var fetuses: [SaveRegularObservationsRequestFetuses]?

    public init(activityId: String? = nil, documentUniqueId: String? = nil, date: Date? = nil, offsetDate: Date? = nil, weight: Double? = nil, bloodPressure: SaveRegularObservationsRequestBloodPressure? = nil, urine: [String]? = nil, edema: String? = nil, pubismeasurement: Double? = nil, fetuses: [SaveRegularObservationsRequestFetuses]? = nil) {
        self.activityId = activityId
        self.documentUniqueId = documentUniqueId
        self.date = date
        self.offsetDate = offsetDate
        self.weight = weight
        self.bloodPressure = bloodPressure
        self.urine = urine
        self.edema = edema
        self.pubismeasurement = pubismeasurement
        self.fetuses = fetuses
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case activityId
        case documentUniqueId
        case date
        case offsetDate
        case weight
        case bloodPressure
        case urine
        case edema
        case pubismeasurement
        case fetuses
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(activityId, forKey: .activityId)
        try container.encodeIfPresent(documentUniqueId, forKey: .documentUniqueId)
        try container.encodeIfPresent(date, forKey: .date)
        try container.encodeIfPresent(offsetDate, forKey: .offsetDate)
        try container.encodeIfPresent(weight, forKey: .weight)
        try container.encodeIfPresent(bloodPressure, forKey: .bloodPressure)
        try container.encodeIfPresent(urine, forKey: .urine)
        try container.encodeIfPresent(edema, forKey: .edema)
        try container.encodeIfPresent(pubismeasurement, forKey: .pubismeasurement)
        try container.encodeIfPresent(fetuses, forKey: .fetuses)
    }
}

