//
// ScanningObservationTableMotherRows.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** A grouping of observation values picked from observations that relate to the mother (or rather are common for all the fetuses) */
public struct ScanningObservationTableMotherRows: Codable, Hashable {

    /** the ID of the careplan activity that these observations are pointing to (using a cross reference) */
    public var activityId: String?
    /** The ID of the CDA document that these observations originate from */
    public var id: String?
    /** The time the measurements were observed */
    public var date: Date?
    /** The time the measurements were created */
    public var createdDate: Date?
    public var measuredBy: HealthCarePerformer?
    /** Always following the week+day notation */
    public var gestationAge: String?
    /** Calculated from gestationAge e.g. (22+1) = 22.14. Will return null if gestationAge is null; */
    public var weeksIntoPregnancy: Double?
    public var amnioticFluid: NumericValueWithUnit?
    public var flow: String?
    public var cervix: NumericValueWithUnit?
    public var dvp: NumericValueWithUnit?

    public init(activityId: String? = nil, id: String? = nil, date: Date? = nil, createdDate: Date? = nil, measuredBy: HealthCarePerformer? = nil, gestationAge: String? = nil, weeksIntoPregnancy: Double? = nil, amnioticFluid: NumericValueWithUnit? = nil, flow: String? = nil, cervix: NumericValueWithUnit? = nil, dvp: NumericValueWithUnit? = nil) {
        self.activityId = activityId
        self.id = id
        self.date = date
        self.createdDate = createdDate
        self.measuredBy = measuredBy
        self.gestationAge = gestationAge
        self.weeksIntoPregnancy = weeksIntoPregnancy
        self.amnioticFluid = amnioticFluid
        self.flow = flow
        self.cervix = cervix
        self.dvp = dvp
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case activityId
        case id
        case date
        case createdDate
        case measuredBy
        case gestationAge
        case weeksIntoPregnancy
        case amnioticFluid
        case flow
        case cervix
        case dvp
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(activityId, forKey: .activityId)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(date, forKey: .date)
        try container.encodeIfPresent(createdDate, forKey: .createdDate)
        try container.encodeIfPresent(measuredBy, forKey: .measuredBy)
        try container.encodeIfPresent(gestationAge, forKey: .gestationAge)
        try container.encodeIfPresent(weeksIntoPregnancy, forKey: .weeksIntoPregnancy)
        try container.encodeIfPresent(amnioticFluid, forKey: .amnioticFluid)
        try container.encodeIfPresent(flow, forKey: .flow)
        try container.encodeIfPresent(cervix, forKey: .cervix)
        try container.encodeIfPresent(dvp, forKey: .dvp)
    }
}

