//
// ScanningObservationTableRows.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

/** A grouping of observation values that relate to the fetus recorded in the same activity */
public struct ScanningObservationTableRows: Codable, Hashable {

    /** The ID of the CDA document that these observations originate from */
    public var id: String?
    /** the ID of the careplan activity that these observations are pointing to (using a cross reference) */
    public var activityId: String?
    /** The time the measurements were observed */
    public var date: Date?
    /** The time the measurements were created */
    public var createdDate: Date?
    public var measuredBy: HealthCarePerformer?
    /** Always following the week+day notation */
    public var gestationAge: String?
    /** Calculated from gestationAge e.g. (22+1) = 22.14. Will return null if gestationAge is null; */
    public var weeksIntoPregnancy: Double?
    public var ulWeight: NumericValueWithUnit?
    public var weightDeviation: RangeValueWithUnit?
    public var fetusPresentation: String?

    public init(id: String? = nil, activityId: String? = nil, date: Date? = nil, createdDate: Date? = nil, measuredBy: HealthCarePerformer? = nil, gestationAge: String? = nil, weeksIntoPregnancy: Double? = nil, ulWeight: NumericValueWithUnit? = nil, weightDeviation: RangeValueWithUnit? = nil, fetusPresentation: String? = nil) {
        self.id = id
        self.activityId = activityId
        self.date = date
        self.createdDate = createdDate
        self.measuredBy = measuredBy
        self.gestationAge = gestationAge
        self.weeksIntoPregnancy = weeksIntoPregnancy
        self.ulWeight = ulWeight
        self.weightDeviation = weightDeviation
        self.fetusPresentation = fetusPresentation
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case activityId
        case date
        case createdDate
        case measuredBy
        case gestationAge
        case weeksIntoPregnancy
        case ulWeight
        case weightDeviation
        case fetusPresentation
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(activityId, forKey: .activityId)
        try container.encodeIfPresent(date, forKey: .date)
        try container.encodeIfPresent(createdDate, forKey: .createdDate)
        try container.encodeIfPresent(measuredBy, forKey: .measuredBy)
        try container.encodeIfPresent(gestationAge, forKey: .gestationAge)
        try container.encodeIfPresent(weeksIntoPregnancy, forKey: .weeksIntoPregnancy)
        try container.encodeIfPresent(ulWeight, forKey: .ulWeight)
        try container.encodeIfPresent(weightDeviation, forKey: .weightDeviation)
        try container.encodeIfPresent(fetusPresentation, forKey: .fetusPresentation)
    }
}

