// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import XCTest
@testable import CMSData

final class CMSTests: XCTestCase {
    func testDictionaryModel() {
        let dictionary = CMSDictionary(items: [
            DictionaryItem(title: "test-1", text: "Text 1"),
            DictionaryItem(title: "test-2", text: "Text 2")
        ])

        XCTAssertTrue(dictionary.hasText(for: "test-1"))
        XCTAssertTrue(dictionary.hasText(for: "test-2"))
        XCTAssertFalse(dictionary.hasText(for: "test-3"))

        XCTAssertEqual(dictionary.text(for: "test-1"), "Text 1")
        XCTAssertEqual(dictionary.text(for: "test-2"), "Text 2")
        XCTAssertNil(dictionary.text(for: "test-3"))
    }
}
