//// The MIT License
////
//// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
////
//// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
////
//// Permission is hereby granted, free of charge, to any person obtaining a copy of
//// this software and associated documentation files (the "Software"), to deal in
//// the Software without restriction, including without limitation the rights to
//// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
//// of the Software, and to permit persons to whom the Software is furnished to do
//// so, subject to the following conditions:
////
//// The above copyright notice and this permission notice shall be included in all
//// copies or substantial portions of the Software.
////
//// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
//// SOFTWARE.
//
//import UIData
//import CMSServices
//import MaternityServices
//import GMAppData
//import ErrorData
//import CMSData
//import Combine
//
//final class ObservationTableServiceImpl: ObservationTableService {
//    @DI private var dictionaryService: DictionaryService
//    @DI private var observationService: ObservationService
//
//    func fetchScanTable(maternityId: String, navigateToActivity: @escaping ((String) -> Void)) -> AnyPublisher<DataTableColumnSet, ServiceError> {
//        dictionaryService.fetchDictionaryWithEmptyFallback()
//            .setFailureType(to: ServiceError.self)
//            .flatMap({ (dictionary: CMSDictionary) -> AnyPublisher<DataTableColumnSet, ServiceError> in
//                self.observationService.fetchObservationsTableScan(maternityId: maternityId)
//                    .map({ (table: ScanningObservationTable) -> DataTableColumnSet in
//                        table.toDataTableColumnSet(dictionary: dictionary, navigateToActivity: navigateToActivity)
//                    })
//                    .eraseToAnyPublisher()
//            })
//            .eraseToAnyPublisher()
//    }
//
//    func fetchClinicalTable(maternityId: String, navigateToActivity: @escaping ((String) -> Void)) -> AnyPublisher<DataTableClinicalResult, ServiceError> {
//        dictionaryService.fetchDictionaryWithEmptyFallback()
//            .setFailureType(to: ServiceError.self)
//            .flatMap({ (dictionary: CMSDictionary) -> AnyPublisher<DataTableClinicalResult, ServiceError> in
//                self.observationService.fetchObservationsTableClinical(maternityId: maternityId)
//                    .map({ (table: ObservationTable) -> DataTableClinicalResult in
//                        let columnSet = table.toDataTableColumnSet(dictionary: dictionary, navigateToActivity: navigateToActivity)
//                        return DataTableClinicalResult(
//                            tableColumnSet: columnSet,
//                            pubisMeasurements: (table.mother?.rows?.compactMap({ row in
//                                guard let value = row.pubismeasurement?.value, let unit = row.pubismeasurement?.unit, let pregnancyWeek: Double = row.weeksIntoPregnancy else {
//                                    return nil
//                                }
//                                return PubisMeasurementChartEntry(
//                                    maternityWeek: pregnancyWeek,
//                                    value: value,
//                                    unit: unit
//                                )
//                            }) ?? []).sorted(by: \.maternityWeek)
//                        )
//
//                    })
//                    .eraseToAnyPublisher()
//            })
//            .eraseToAnyPublisher()
//    }
//}
