//// The MIT License
////
//// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
////
//// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
////
//// Permission is hereby granted, free of charge, to any person obtaining a copy of
//// this software and associated documentation files (the "Software"), to deal in
//// the Software without restriction, including without limitation the rights to
//// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
//// of the Software, and to permit persons to whom the Software is furnished to do
//// so, subject to the following conditions:
////
//// The above copyright notice and this permission notice shall be included in all
//// copies or substantial portions of the Software.
////
//// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
//// SOFTWARE.
//
//import Foundation
//import MaternityServices
//import ErrorData
//import UIData
//import Combine
//import CMSServices
//
//final class ScanningResultsServiceImpl : ScanningResultsService {
//    @DI private var maternityEnvironmentStore: MaternityDataEnvironmentStore
//    @DI private var dictionaryService: DictionaryService
//
//    //swiftlint:disable:next function_body_length
//    func fetchOtherResults() -> AnyPublisher<[KeyValueModel], ServiceError> {
//        let maternity = maternityEnvironmentStore.selectedMaternity
//        let riskAssessmentSection = maternity?.prenatalRiskAssessmentSection
//        let ultraSoundSection = maternity?.ultrasoundSection
//
//        return dictionaryService.fetchDictionaryWithEmptyFallback()
//            .map({ (dictionary) -> [KeyValueModel] in
//                [
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_expected_date_of_delivery_from_prenatal_ultrasound_scan(),
//                        primaryValue: JournalDateFormatter.format(date: ultraSoundSection?.expectedDateOfDeliveryFromPrenatalUltrasoundScan),
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_downs_probability(),
//                        primaryValue: riskAssessmentSection?.riskAssessment3?.downsScreeningProbabilityAssessment?.description,
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_double_test(),
//                        primaryValue: JournalDateFormatter.format(date: riskAssessmentSection?.riskAssessment3?.doubleTestCompletedDate),
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_multiple_risk_factors(),
//                        primaryValue: riskAssessmentSection?.riskAssessment2?.multiplicityRiskAssessment?.risk?.description,
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_multiple_risk_factors_remarks(),
//                        primaryValue: riskAssessmentSection?.riskAssessment2?.multiplicityRiskAssessment?.comment,
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_amount_of_fetuses(),
//                        primaryValue: maternity?.numberOfFetuses.description,
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_placental_biopsy_observation(),
//                        primaryValue: riskAssessmentSection?.riskAssessment5?.placentalBiopsiObservation?.result,
//                        secondaryValue: JournalDateFormatter.format(date: riskAssessmentSection?.riskAssessment5?.placentalBiopsiObservation?.date),
//                        dictionary: dictionary
//                    ),
//                    KeyValueModel.dictionaryModel(
//                        title: Localizable.journal_section_scans_prenatal_amniocentesis_observation(),
//                        primaryValue: riskAssessmentSection?.riskAssessment6?.prenatalAmniocentesisiObservation?.result,
//                        secondaryValue: JournalDateFormatter.format(date: riskAssessmentSection?.riskAssessment6?.prenatalAmniocentesisiObservation?.date),
//                        dictionary: dictionary
//                    )
//                ]
//            })
//            .mapToServiceError()
//            .eraseToAnyPublisher()
//    }
//}
