//
// MeasurementType.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation

/** The type of the measurement, specified in the &#39;name&#39; enum. If there is a help text for the type, an &#39;hasInfo&#39; will be true. The &#39;name&#39; attribute can then be resolved to a help text in the &#39;TODO&#39; endpoint.  */
public struct MeasurementType: Codable, Hashable {

    public enum Name: String, Sendable, Codable, CaseIterable {
        case bodyMassIndex = "BodyMassIndex"
        case lengthOfUterineCervix = "LengthOfUterineCervix"
        case uterineMembraneFeature = "UterineMembraneFeature"
        case bloodPressure = "BloodPressure"
        case presenceOfErythrocytesInUrine = "PresenceOfErythrocytesInUrine"
        case fetalMovementActivity = "FetalMovementActivity"
        case numberOfFetuses = "NumberOfFetuses"
        case presentationOfFetus = "PresentationOfFetus"
        case estimatedFetalWeight = "EstimatedFetalWeight"
        case amnioticFluidProduction = "AmnioticFluidProduction"
        case gestationalAge = "GestationalAge"
        case urinaryGlucoseOutput = "UrinaryGlucoseOutput"
        case heartSounds = "HeartSounds"
        case standingHeight = "StandingHeight"
        case presenceOfKetonesInUrine = "PresenceOfKetonesInUrine"
        case riskOfChromosomalDisorder = "RiskOfChromosomalDisorder"
        case presenceOfLeukocytesInUrine = "PresenceOfLeukocytesInUrine"
        case presenceOfNitriteInUrine = "PresenceOfNitriteInUrine"
        case positionOfPlacentaInUterus = "PositionOfPlacentaInUterus"
        case presenceOfProteinInUrine = "PresenceOfProteinInUrine"
        case fundalHeightOfUterus = "FundalHeightOfUterus"
        case estimatedDateOfDeliveryFromAntenatalUltrasoundScan = "EstimatedDateOfDeliveryFromAntenatalUltrasoundScan"
        case estimatedFetalWeightByUltrasound = "EstimatedFetalWeightByUltrasound"
        case presentationOfFetusByUltrasound = "PresentationOfFetusByUltrasound"
        case bodyWeight = "BodyWeight"
        case percentageOfReferenceWeight = "PercentageOfReferenceWeight"
        case gradeOfEdema = "GradeOfEdema"
        case locationOfEdema = "LocationOfEdema"
    }
    public var name: Name
    public var hasInfo: Bool
    public var chartData: ChartData?

    public init(name: Name, hasInfo: Bool, chartData: ChartData? = nil) {
        self.name = name
        self.hasInfo = hasInfo
        self.chartData = chartData
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case name
        case hasInfo
        case chartData
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(name, forKey: .name)
        try container.encode(hasInfo, forKey: .hasInfo)
        try container.encodeIfPresent(chartData, forKey: .chartData)
    }
}

