// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import Foundation

extension String {
    enum LoremIpsum {
        case small
        case medium
        case large
        case huge
    }
    static func loremIpsum(_ style: LoremIpsum) -> String {
        switch style {
        case .small:
            return "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum ac nibh non quam porta molestie vitae ac ligula. Nullam vitae mattis turpis."
        case .medium:
            // swiftlint:disable:next line_length
            return "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Tortor pretium viverra suspendisse potenti nullam. Erat imperdiet sed euismod nisi porta lorem mollis aliquam ut. Sagittis vitae et leo duis ut. Hac habitasse platea dictumst quisque sagittis purus. In egestas erat imperdiet sed."
        case .large:
            // swiftlint:disable:next line_length
            return "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum ac nibh non quam porta molestie vitae ac ligula. Nullam vitae mattis turpis. Curabitur egestas sem lacus, nec rutrum metus accumsan in. Quisque ex nisi, scelerisque finibus velit eu, porta luctus neque. Nulla magna diam, sollicitudin vulputate faucibus quis, tincidunt vitae augue. Curabitur placerat, lectus sed posuere tincidunt, diam turpis rutrum neque, tempor tristique urna nibh et sem. Nulla suscipit massa velit, vel tempor nisl consequat vitae. Integer euismod finibus metus eu dignissim. Nam aliquam neque consectetur tempus cursus. Proin ut gravida augue. Phasellus sodales lorem libero, quis sagittis lectus maximus at. Duis ac ante sapien. Quisque vulputate quis magna sit amet aliquet. Donec accumsan elit mi, et dictum orci scelerisque id. Donec placerat lectus sodales dolor sollicitudin, eget rhoncus nulla condimentum. Praesent quis rhoncus ipsum."
        case .huge:
            return (0...10).map({ _ in
                Self.loremIpsum(.large)
            }).joined(separator: "\n")
        }
    }
}
