// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import GMAppData

extension PersonalDataSectionNextOfKin.Relation : CustomStringConvertible {
    public var description: String {
        switch self {
        case .ægtefælle: return Localizable.journal_section_personal_data_next_of_kin_relation_spouse()
        case .anden: return Localizable.journal_section_personal_data_next_of_kin_relation_other()
        case .barn: return Localizable.journal_section_personal_data_next_of_kin_relation_child()
        case .barnebarn: return Localizable.journal_section_personal_data_next_of_kin_relation_grand_child()
        case .datter: return Localizable.journal_section_personal_data_next_of_kin_relation_daughter()
        case .far: return Localizable.journal_section_personal_data_next_of_kin_relation_father()
        case .forælder: return Localizable.journal_section_personal_data_next_of_kin_relation_parent()
        case .ingenRelationer: return Localizable.journal_section_personal_data_next_of_kin_relation_no_relations()
        case .mor: return Localizable.journal_section_personal_data_next_of_kin_relation_mother()
        case .nabo: return Localizable.journal_section_personal_data_next_of_kin_relation_neighbor()
        case .registreretPartner: return Localizable.journal_section_personal_data_next_of_kin_relation_registered_partner()
        case .samboende: return Localizable.journal_section_personal_data_next_of_kin_relation_live_together()
        case .svigerbarn: return Localizable.journal_section_personal_data_next_of_kin_relation_child_in_law()
        case .søn: return Localizable.journal_section_personal_data_next_of_kin_relation_son()
        case .søskende: return Localizable.journal_section_personal_data_next_of_kin_relation_sibling()
        case .uspecPårørende: return Localizable.journal_section_personal_data_next_of_kin_relation_unspecified_relative()
        case .øvrigFamilie: return Localizable.journal_section_personal_data_next_of_kin_relation_other_family()
        }
    }
}
