//
//  OurTimDataStorage.swift
//  MinGraviditet
//
//  Created by Casper Christensen on 31/03/2025.
//

import TIM
import Combine
import TIMEncryptedStorage

class OurTimDataStorage: TIMDataStorage {
    
    init() {
        self.availableUserIds = []
    }
    
    func storeRefreshTokenWithLongSecret(_ refreshToken: JWT, longSecret: String, completion: @escaping (Result<Void, TIMError>) -> Void) {
                completion(.success(()))
    }
    
    func enableBiometricAccessForRefreshToken(longSecret: String, userId: String) -> Result<Void, TIMError> {
        return .success(())
    }
    
    func enableBiometricAccessForRefreshToken(password: String, userId: String, completion: @escaping (Result<Void, TIMError>) -> Void) {
        completion(.success(()))
    }
    
    func storeRefreshToken(_ refreshToken: JWT, withNewPassword newPassword: String, completion: @escaping (Result<TIMESKeyCreationResult, TIMError>) -> Void) {
        let result = TIMESKeyCreationResult(keyId: "123", longSecret: "long secret")
              completion(.success(result))
    }
    
    func storeRefreshToken(_ refreshToken: JWT, withExistingPassword password: String, completion: @escaping (Result<Void, TIMError>) -> Void) {
        completion(.success(()))
    }
    
    func getStoredRefreshTokenViaBiometric(userId: String, willBeginNetworkRequests: WillBeginNetworkRequestsCallback?, completion: @escaping (Result<BiometricRefreshToken, TIMError>) -> Void) {
        completion(Result.failure(TIMError.storage(TIMStorageError.incompleteUserDataSet)))
    }

    func getStoredRefreshToken(userId: String, password: String, completion: @escaping (Result<JWT, TIMError>) -> Void) {
        completion(Result.failure(TIMError.storage(TIMStorageError.incompleteUserDataSet)))
    }
    
    var availableUserIds: Set<String> = []
    
    func hasRefreshToken(userId: String) -> Bool {
        return false
    }
    
    func hasBiometricAccessForRefreshToken(userId: String) -> Bool {
        return false
    }
    
    func disableBiometricAccessForRefreshToken(userId: String) {
        
    }
    
    func clear(userId: String) {
        
    }
}

extension OurTimDataStorage {
    func getStoredRefreshToken(userId: String, password: String) -> Future<JWT, TIMError> {
        Future { promise in
            self.getStoredRefreshToken(userId: userId, password: password, completion: promise)
        }
    }

    func getStoredRefreshTokenViaBiometric(userId: String, willBeginNetworkRequests: WillBeginNetworkRequestsCallback?) -> Future<BiometricRefreshToken, TIMError> {
        Future { promise in
            self.getStoredRefreshTokenViaBiometric(userId: userId, willBeginNetworkRequests: willBeginNetworkRequests, completion: promise)
        }
    }

    func storeRefreshToken(_ refreshToken: JWT, withExistingPassword password: String) -> Future<Void, TIMError> {
        Future { promise in
            self.storeRefreshToken(refreshToken, withExistingPassword: password, completion: promise)
        }
    }

    func storeRefreshToken(_ refreshToken: JWT, withNewPassword newPassword: String) -> Future<TIMESKeyCreationResult, TIMError> {
        Future { promise in
            self.storeRefreshToken(refreshToken, withNewPassword: newPassword, completion: promise)
        }
    }

    func enableBiometricAccessForRefreshToken(password: String, userId: String) -> Future<Void, TIMError> {
        Future { promise in
            self.enableBiometricAccessForRefreshToken(password: password, userId: userId, completion: promise)
        }
    }

    func storeRefreshTokenWithLongSecret(_ refreshToken: JWT, longSecret: String) -> Future<Void, TIMError> {
        Future { promise in
            self.storeRefreshTokenWithLongSecret(refreshToken, longSecret: longSecret, completion: promise)
        }
    }
}

