// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import UIKit

final class Metrics {
    
    struct Lengths {
        static let pinCode: UInt = 4
    }
    
    struct Margins {
        static let numberKeyboardBottom: CGFloat = 32
    }
    
    struct Radius {
        static let radius0: CGFloat = 0
        static let radius2: CGFloat = 2
        static let radius4: CGFloat = 4
        static let radius8: CGFloat = 8
        static let radius12: CGFloat = 12
        static let radius16: CGFloat = 16
        static let radius24: CGFloat = 24
        static let radiusCircle: CGFloat = 999
    }
    
    struct Spacing {
        static let minimum: CGFloat = 1
        static let narrowCardSpacing: CGFloat = 8
        static let appointmentsDisplayValuesSpacing: CGFloat = 8
        
        static let searchBarTopBottomMargin: CGFloat = 15
        
        // New spacing tokens
        static let space0: CGFloat = 0
        static let space02: CGFloat = 2
        static let space4: CGFloat = 4
        static let space8: CGFloat = 8
        static let space12: CGFloat = 12
        static let space16: CGFloat = 16
        static let space20: CGFloat = 20
        static let space24: CGFloat = 24
        static let space32: CGFloat = 32
        static let space40: CGFloat = 40
        static let space48: CGFloat = 48
        static let space64: CGFloat = 64
        static let space96: CGFloat = 96
        static let space144: CGFloat = 144
        static let space208: CGFloat = 208
        static let space304: CGFloat = 304
        static let space448: CGFloat = 448
    }
    
    struct Sizes {
        static let textFieldRadius: CGFloat = 10
        static let textFieldHeight: CGFloat = 36
        
        static let cardCornerRadius: CGFloat = 12
        static let pinCodeCircleSize: CGFloat = 40
        
        static let buttonHeight: CGFloat = 50
        
        static let numberKeyboardButtonHeight: CGFloat = 46
        static let numberKeyboardHeight: CGFloat = 184
        
        static let checklistProgressSize: CGFloat = 94
        static let checkmarkSize: CGFloat = 32
        
        static let timelineLineWidth: CGFloat = 2
        
        static let navigationRowHeight: CGFloat = 52
        
        static let overviewHeaderValueHeight: CGFloat = 32
        static let overviewHeaderDefaultValueWidth: CGFloat = 30
        static let overviewHeaderWeekWidth: CGFloat = 80
        static let overviewHeaderGaveBirthButtonWidth: CGFloat = 70
        static let overviewHeaderDateWidth: CGFloat = 130
    }
}
