// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import SwiftUI

struct BubblesBackgroundView: View {
    var size: CGSize?

    var body: some View {
        if let size = size {
            imageBubbles(containerSize: size)
        } else {
            GeometryReader { geo in
                imageBubbles(containerSize: geo.size)
            }
        }
    }

    @ViewBuilder
    private func imageBubbles(containerSize: CGSize) -> some View {
        Image(R.image.illustrations.backgroundCircles.name)
            .resizable()
            .scaledToFill()
            .frame(width: containerSize.width, height: containerSize.height)
            .accessibility(hidden: true)
    }
}

struct LoginBackgroundView_Previews: PreviewProvider {
    static var previews: some View {
        BubblesBackgroundView()
    }
}
