// The MIT License
//
// Original work sponsored and donated by The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Copyright (C) 2020 The Danish Health Data Authority (http://www.sundhedsdatastyrelsen.dk)
//
// Permission is hereby granted, free of charge, to any person obtaining a copy of
// this software and associated documentation files (the "Software"), to deal in
// the Software without restriction, including without limitation the rights to
// use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
// of the Software, and to permit persons to whom the Software is furnished to do
// so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

import XCTest
@testable import CMSServices
@testable import MinGraviditet

final class PagesIntegrationTests: CMSIntegrationTestCase {
    func testAboutTheApp() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchAboutTheApp()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testBehindTheApp() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchBehindTheApp()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testConsent() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchConsent()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testMasterData() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchMasterData()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testMyLog() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchMyLog()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testMyLocking() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchMyLocking()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testPrivacyPolicy() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchPrivacyPolicy()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

    func testSupport() {
        let pageService = PagesServiceImpl()
        performAndWait(pageService.fetchSupport()) { (page) in
            XCTAssertGreaterThan(page.content.count, 0)
            XCTAssertGreaterThan(page.title.count, 0)
        }
    }

}
