import Foundation
import CMSData

extension SearchResultDTO {
    func toDomain() -> SearchResultDomain {
        SearchResultDomain(
            title: title,
            categoryName: categoryName,
            categoryIcon: categoryIcon,
            content: content,
            reference: reference(),
            articleId: unwrappedArticleId,
            articleName: articleName
        )
    }
    
    func reference() -> SearchResultDomainReference {
        guard let sectionId = sectionId else {
            return .Article
        }
        return .ArticleSection(sectionId: sectionId)
    }
}

extension Sequence where Element == SearchResultDTO {
    public func toDomain() -> [SearchResultDomain] {
        map { (dto: SearchResultDTO ) in
            dto.toDomain()
        }
    }
}
